> For the complete documentation index, see [llms.txt](https://docs.xverse.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.xverse.app/api/runes/runes-by-address/v2-rune-balances-mempool-aware.md).

# \[v2] Rune Balances (Mempool-Aware)

## GET /v2/runes/address/{address}/balance

> Get confirmed and unconfirmed runes balance.\
> &#x20;       \<code>balance\</code> fields explained:\
> &#x20;       \<ul>\
> &#x20;       \<li> \<code>confirmedBalance\</code> is the rune balance ignoring unconfirmed transactions in mempool.\</li>\
> &#x20;         \<li> \<code>availableBalance\</code> is the confirmed balance minus amounts used by any\
> &#x20;         outgoing unconfirmed transaction in mempool.\</li>\
> &#x20;         \<li> \<code>projectedBalance\</code> is the final balance if all unconfirmed mempool\
> &#x20;          transactions are confirmed.\</li>\
> &#x20;         \<li> \<code>pendingBalance\</code> is a breakdown of the unconfirmed transactions amounts.\
> &#x20;         They represent aggregate amounts for the whole mempool activity, so as more\
> &#x20;         transactions are chained together the amounts will increase.\
> &#x20;           \<ul>\
> &#x20;             \<li> \<code>incomingAmount\</code> is the sum of all incoming unconfirmed amounts.\</li>\
> &#x20;             \<li> \<code>outgoingAmount\</code> is the sum of all outgoing unconfirmed amounts.\</li>\
> &#x20;             \<li> \<code>netAmount\</code> is \<code>incoming\</code> - \<code>outgoing\</code>.\
> &#x20;             The \<code>netAmount\</code> can be negative,\
> &#x20;             when sending more than receiving. It should always match what is expected to be added to\
> &#x20;             the confirmed balance when all unconfirmed transactions are confirmed, which is computed\
> &#x20;             as \<code>projectedBalance\</code> for convenience.\</li>\
> &#x20;           \</ul>\
> &#x20;         \</li>\
> &#x20;         \</ul>\
> &#x20;        &#x20;

```json
{"openapi":"3.0.3","info":{"title":"SecretKeyLabs API","version":"1.0.0"},"tags":[],"servers":[{"url":"https://api.secretkeylabs.io"}],"security":[{"apiKey":[]}],"components":{"securitySchemes":{"apiKey":{"type":"apiKey","name":"x-api-key","in":"header"}}},"paths":{"/v2/runes/address/{address}/balance":{"get":{"tags":["Runes"],"description":"Get confirmed and unconfirmed runes balance.\n        <code>balance</code> fields explained:\n        <ul>\n        <li> <code>confirmedBalance</code> is the rune balance ignoring unconfirmed transactions in mempool.</li>\n          <li> <code>availableBalance</code> is the confirmed balance minus amounts used by any\n          outgoing unconfirmed transaction in mempool.</li>\n          <li> <code>projectedBalance</code> is the final balance if all unconfirmed mempool\n           transactions are confirmed.</li>\n          <li> <code>pendingBalance</code> is a breakdown of the unconfirmed transactions amounts.\n          They represent aggregate amounts for the whole mempool activity, so as more\n          transactions are chained together the amounts will increase.\n            <ul>\n              <li> <code>incomingAmount</code> is the sum of all incoming unconfirmed amounts.</li>\n              <li> <code>outgoingAmount</code> is the sum of all outgoing unconfirmed amounts.</li>\n              <li> <code>netAmount</code> is <code>incoming</code> - <code>outgoing</code>.\n              The <code>netAmount</code> can be negative,\n              when sending more than receiving. It should always match what is expected to be added to\n              the confirmed balance when all unconfirmed transactions are confirmed, which is computed\n              as <code>projectedBalance</code> for convenience.</li>\n            </ul>\n          </li>\n          </ul>\n          ","parameters":[{"schema":{"type":"string"},"in":"query","name":"runeId","required":false},{"schema":{"type":"boolean"},"in":"query","name":"includePricing","required":false},{"schema":{"minLength":10,"default":"bc1q0egjvlcfq77cxd9kvpgppyuxckzvws46e3sxch","format":"BitcoinAddress","type":"string"},"in":"path","name":"address","required":true}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"balances":{"type":"array","items":{"type":"object","properties":{"runeId":{"type":"string"},"divisibility":{"type":"number"},"symbol":{"type":"string"},"runeName":{"type":"string"},"confirmedBalance":{"description":"Confirmed balance, ignoring mempool","type":"string"},"availableBalance":{"description":"Confirmed balance minus spent in mempool amounts","type":"string"},"projectedBalance":{"description":"Confirmed balance plus unconfirmed amounts. Final balance if all get confirmed.","type":"string"},"pendingBalance":{"description":"Breakdown of unconfirmed/mempool amounts","type":"object","properties":{"incomingAmount":{"description":"Sum of all incoming unconfirmed amounts","type":"string"},"outgoingAmount":{"description":"Sum of all outgoing unconfirmed amounts","type":"string"},"netAmount":{"description":"Incoming - Outgoing","type":"string"}},"required":["incomingAmount","outgoingAmount","netAmount"]},"prices":{"type":"object","properties":{"floorPrice":{"type":"object","allOf":[{"type":"object","properties":{"marketplace":{"type":"string"},"percentageChange24h":{"type":"object","properties":{"valueInSats":{"type":"string"},"valueInUsd":{"type":"string"}}}},"required":["percentageChange24h"]},{"type":"object","properties":{"valueInSats":{"type":"string"},"valueInUsd":{"type":"string"}}}]},"lastSalePrice":{"type":"object","allOf":[{"type":"object","properties":{"marketplace":{"type":"string"}}},{"type":"object","properties":{"valueInSats":{"type":"string"},"valueInUsd":{"type":"string"}}}]}},"required":["floorPrice","lastSalePrice"]},"volume24h":{"type":"object","allOf":[{"type":"object","properties":{"percentageChange":{"type":"object","properties":{"valueInSats":{"type":"string"},"valueInUsd":{"type":"string"}}}},"required":["percentageChange"]},{"type":"object","properties":{"valueInSats":{"type":"string"},"valueInUsd":{"type":"string"}}}]}},"required":["runeId","confirmedBalance","availableBalance","projectedBalance","pendingBalance"]}},"indexerHeight":{"description":"Last height indexed by the runes indexer","type":"number"}},"required":["balances","indexerHeight"]}}}},"400":{"description":"Invalid input","content":{"application/json":{"schema":{"description":"Invalid input","type":"string"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"description":"Unauthorized","type":"string"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"description":"Not found","type":"string"}}}},"429":{"description":"Rate limit exceeded","content":{"application/json":{"schema":{"description":"Rate limit exceeded","type":"string"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"description":"Internal server error","type":"string"}}}}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.xverse.app/api/runes/runes-by-address/v2-rune-balances-mempool-aware.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
